﻿var
  EscKeyPressed: Boolean;
  Timer1: TTimer;
  WMP: TWindowsMediaPlayer;
  reg: TRegistry;
  iDays: integer;

procedure frmVideo_OnShow (Sender: TObject; Action: string);
begin
    WMP:= TWindowsMediaPlayer.Create(frmVideo);
    With WMP do
    begin
        TabOrder:= 1;
        Align:= alclient;
        Parent:= frmVideo.Panel1;
        Visible:= true;
     end;

    WMP.set_volume(100);
    WMP.stretchToFit:= 1; // stretch video
    WMP.enableContextMenu:= 1;
    WMP.uiMode:= 'full';
end;

procedure frmVideo_OnClose (Sender: TObject; Action: string);
begin
    WMP.Stop;
    WMP.Free;
end;

procedure frmVideo_Button1_OnClick (Sender: TObject; var Cancel: boolean);
var
    OpenDialog: TOpenDialog;
begin
    OpenDialog := TOpenDialog.Create(Form1);
    if OpenDialog.Execute then WMP.URL := OpenDialog.FileName;
    OpenDialog.Free;
end;

procedure Form1_TableGrid2_OnChange (Sender: TObject);
begin
  // The following assigns a color to hearders and footers for Tablegrid2
  Form1.Tablegrid2.Columns[0].Header.Color := $002C8BBA;
  Form1.Tablegrid2.Columns[1].Header.Color := $002C8BBA;
  Form1.Tablegrid2.Columns[2].Header.Color := $002C8BBA;
  Form1.Tablegrid2.Columns[3].Header.Color := $002C8BBA;
  Form1.Tablegrid2.Columns[4].Header.Color := $002C8BBA;
  Form1.Tablegrid2.Columns[0].Footer.Color := $002C8BBA;
  Form1.Tablegrid2.Columns[1].Footer.Color := $002C8BBA;
  Form1.Tablegrid2.Columns[2].Footer.Color := $002C8BBA;
  Form1.Tablegrid2.Columns[3].Footer.Color := $002C8BBA;
  Form1.Tablegrid2.Columns[4].Footer.Color := $002C8BBA;
end;

procedure frmSplash_OnShow (Sender: TObject; Action: string);
begin
   Timer1 := TTimer.Create(frmSplash);
   Timer1.Interval := 5000;
   Timer1.OnTimer := @OnTimer1;
end;

procedure Form1_OnKeyUp (Sender: TObject; var Key: Word; Shift, Alt, Ctrl: boolean);
begin
   if Key=27 then EscKeyPressed := True;      // If Esc key was pressed set the EscKeyPressed variable
end;                   

procedure Form1_OnShow (Sender: string; TObject: string; Action: string); //** show welcome message and update the counts
begin
     reg := TRegistry.Create;
     reg.Access := KEY_ALL_ACCESS;
     reg.RootKey := HKEY_CURRENT_USER;
     reg.OpenKey('Software\Oscars',true);
     if not reg.ValueExists('StartDate') then reg.WriteDate('StartDate', Now+30); // trial period is 30 days

     iDays := Trunc(reg.ReadDate('StartDate')) - Trunc(Now); // time left days

     reg.CloseKey;
     reg.Free;

     if iDays < 1 then
     begin
          MessageBox('Trial period is over.'+ #13#10#13#10 + 'Please contact Darek Dorozinski to obtain a registered version.','Trial Expired',MB_Ok+MB_ICONSTOP);
          Form1.Close;
          Exit;
     end;

     Form1.Caption := 'MovieStarsOscars Trial - Days Left in Trial Period: ' + InttoStr(idays);

  frmSplash.ShowModal; // Show welcome screen
  form1.button7.click;
  form1.tablegrid1.SelectedRow:= 0;
  form1.Button8.Click;
  derekupdate;
  //showmessage('Welcome To The Oscars');
end;

procedure OnTimer1 (Sender: TObject);
begin
     Timer1.Enabled := False;
     frmSplash.Close;
     Timer1.Free;
   end;

procedure frmSplash_Button1_OnClick (Sender: string; var Cancel: boolean);
begin
    Timer1.Enabled := False;
    Timer1.Free;
    frmSplash.Close;
   end;


 procedure Form1_btnImport_OnClick (Sender: TObject; var Cancel: boolean);
var
   ProgressBar: TProgressBar;
   OpenDialog: TOpenDialog;
   CSV: TCSV;
   iLine,iField,c,films_id,cat_id,winner: integer;
   s: string;
   SqliteTr: TDBXSqliteTransaction;
begin
     EscKeyPressed := False;                       // Set the EscKeyPressed variable to false
     Form1.lblCount.Caption := '';                 // Clear the count label
     OpenDialog := TOpenDialog.Create(Form1);      // Open Dialog to select csv file
     OpenDialog.InitialDir := ExtractFileDir(Application.Exename);
     OpenDialog.DefaultExt := 'csv';
     OpenDialog.Filter := 'CSV files|*.csv';
     if OpenDialog.Execute then       
     begin                                         // If a file was selected then process it
          Form1.TableGrid1.ClearRows;                        // Clear rows in tablegrid1
          Form1.TableGrid1.Columns[0].Footer.Caption := '';  // Clear tablegrid footer
          Form1.TableGrid1.Columns[2].Footer.Caption := '';  // Clear tablegrid footer
          Form1.TableGrid1.Columns[3].Footer.Caption := '';  // Clear tablegrid footer
          form1.label8.caption := '0';                       // Clear General Statistics
          form1.label9.caption := '0';                       // Clear General Statistics
          form1.label10.caption := '0';                      // Clear General Statistics
          form1.label11.caption := '0';                      // Clear General Statistics
          Screen.Cursor := crHourGlass;                      // Change mouse cursor while processing

                   
          CSV := TCSV.Create;                                // Setup CSV import
          CSV.FieldSeparator := ';';
          CSV.LoadUtf8File (OpenDialog.FileName);   // Load selected csv file
          c := CSV.LineCount - 1;

          // Remove data from the tables and reset the id sequence to 1
          SQLExecute('PRAGMA foreign_keys=OFF');    // Turn off foreign key checks
          SqlExecute('Delete From films');
          SqlExecute('Delete From categories');
          SqlExecute('Delete From nominations');
          SqlExecute('Delete from sqlite_sequence where name=''films''');
          SqlExecute('Delete from sqlite_sequence where name=''categories''');
          SqlExecute('Delete from sqlite_sequence where name=''nominations''');

          // ProgressBar Setup
          ProgressBar := TProgressBar.Create(Form1);
          ProgressBar.Parent := Form1.pnProgressBar;
          ProgressBar.Width := Form1.pnProgressBar.Width;
          ProgressBar.Height := Form1.pnProgressBar.Height;
          ProgressBar.Position := 0;
          ProgressBar.Max := c;
          Form1.pnProgressBar.Visible := True;

          // Process the csv lines
          SqliteTr := BeginSQLiteTransaction;
          for iLine := 1 to c do    // Skip the first line. It contains headers.
          begin
               If EscKeyPressed then
                 Begin
                   MessageBox('Import Stopped','Canceled',MB_OK+MB_ICONSTOP);
                   Break;
                 End;
                 
               // Import into films table. If there is a title and year already existing then do not insert. Field 2 (relative to 0) in csv file is title, field 3 is year.
               s := ReplaceStr(CSV.Fields[iLine,2], '"', '');
               If SqlExecute('Select count(id) from films where title = "' + s + '" and year = "' + CSV.Fields[iLine,3] + '"') = 0 then
                 Begin
                   SqlExecute ('INSERT INTO films (title, year) VALUES ("' + s + '","' + CSV.Fields[iLine,3] + '")');
                   Form1.lblCount.Caption := 'Reading CSV record ' + IntToStr(iLine+1) + ' out of ' + IntToStr(c+1) + ' Records';
                 End;                           

               // Import into category table. If there is a category already existing then do not insert. Field 4 is category.
               If SqlExecute('Select count(id) from categories where category = "' + CSV.Fields[iLine,4] + '"') = 0 then
                 Begin
                   SqlExecute ('INSERT INTO categories (category) VALUES ("' + CSV.Fields[iLine,4] +'")');
                 End;

               // Import into nominations table. Retrieve the film id and category_id from the films and categories to insert into their respective reference fields
               films_id := SqlExecute('Select id from films where title = "' + s + '" and year = "' + CSV.Fields[iLine,3] + '"');
               cat_id := SqlExecute('Select id from categories where category = "' + CSV.Fields[iLine,4] + '"');
               If CSV.Fields[iLine,1] = '*' then winner := 1 else winner := 0;
               s := ReplaceStr(CSV.Fields[iLine,5], '"', '');
               SqlExecute ('INSERT INTO nominations (id_films, id_categories, nominees, winner) VALUES (' + IntToStr(films_id) + ',' + IntToStr(cat_id) + ',"' + s + '",' + intToStr(winner) +')');

               // Move progressbar position
               ProgressBar.Position := ProgressBar.Position + 1;
               Application.ProcessMessages;
          end;
          CommitSQLiteTransaction(SqliteTr);
          SQLExecute('PRAGMA foreign_keys=ON');     // Turn on foreign keys
          CSV.Free;             // Free the CSV list
          ProgressBar.Free;     // Free the progressbar
          Form1.pnProgressBar.Visible := False;   // Hide progressbar
          If EscKeyPressed then Form1.lblCount.Caption := 'Import Stopped - Not Completed' else
                Form1.lblCount.Caption := 'Import Completed';
          sqlexecute('update films set nomcount = (select count(*) from nominations where nominations.id_films = films.id)');
          sqlexecute('update films set wincount = (select count(*) from nominations where nominations.id_films = films.id and nominations.winner = 1)');
          derekupdate;              // Update counts and update tablegrid with new records
     end;
     Screen.Cursor := crDefault;    // Change mouse cursor back to normal
     OpenDialog.Free;    // Free the File Selection Dialog
end;

procedure Form1_Edit1_OnEnter (Sender: TObject); //** clear nominations search and grid when using keyboard
begin
  form1.edit2.clear;
  form1.tablegrid2.clearrows;
  Form1.Button7.Click;
end;

procedure Form1_Edit1_OnMouseDown (Sender: TObject; MouseLeft, MouseRight, MouseMiddle: boolean; Shift, Alt, Ctrl: boolean; X, Y: Integer); //** by mouse
begin
  form1.edit2.clear;
  form1.tablegrid2.clearrows;
end;

procedure Form1_Edit2_OnEnter (Sender: TObject); //** clear film search and grid when using keyboard
begin
  form1.edit1.clear;
  form1.tablegrid1.clearrows;
end;

procedure Form1_Edit2_OnMouseDown (Sender: TObject; MouseLeft, MouseRight, MouseMiddle: boolean; Shift, Alt, Ctrl: boolean; X, Y: Integer); //** by mouse
begin
  form1.edit1.clear;
  form1.tablegrid1.clearrows;
end;

procedure Form1_TableGrid1_OnClick (Sender: TObject); //** clear nominations grid when user clicks in film search
begin
  form1.edit2.clear;
end;

procedure Formnom_OnShow (Sender: TObject; Action: string); //** pass film id through to nominations form and put title in form2.caption
begin
  formnom.combobox1.dbitemid := form1.tablegrid1.dbitemid;
  formnom.caption := formnom.combobox1.text;
end;

procedure Formnom_Button1_OnAfterClick (Sender: TObject); //** update the counts after saving nominations record
begin
  derekupdate;
end;

procedure Form1_Button6_OnAfterClick (Sender: TObject);  //** update the counts after deleting nominations record
begin
  derekupdate;
end;

procedure Form1_TableGrid1_OnChange (Sender: TObject);  //** update filmcount label when film added or deleted
begin
  form1.label8.caption := sqlexecute('select count(*) from films');

  // The following assigns a color to hearders and footers for Tablegrid1
  Form1.Tablegrid1.Columns[0].Header.Color := $002C8BBA;
  Form1.Tablegrid1.Columns[1].Header.Color := $002C8BBA;
  Form1.Tablegrid1.Columns[2].Header.Color := $002C8BBA;
  Form1.Tablegrid1.Columns[3].Header.Color := $002C8BBA;
  Form1.Tablegrid1.Columns[0].Footer.Color := $002C8BBA;
  Form1.Tablegrid1.Columns[1].Footer.Color := $002C8BBA;
  Form1.Tablegrid1.Columns[2].Footer.Color := $002C8BBA;
  Form1.Tablegrid1.Columns[3].Footer.Color := $002C8BBA;
end;

procedure derekupdate; //** update all counts
begin
  sqlexecute('update films set nomcount = (select count(*) from nominations where id_films = "'+form1.tablegrid1.sqlvalue+'") where id = "'+form1.tablegrid1.sqlvalue+'"');                                
  sqlexecute('update films set wincount = (select count(*) from nominations where id_films = "'+form1.tablegrid1.sqlvalue+'" and winner = 1) where id = "'+form1.tablegrid1.sqlvalue+'"');
  form1.tablegrid1.dbupdate;
  form1.label8.caption := sqlexecute('select count(*) from films');
  form1.label9.caption := sqlexecute('select count(*) from nominations');
  form1.label10.caption := sqlexecute('select count(*) from categories');
  form1.label11.caption := sqlexecute('select count(*) from nominations where winner = 1');
end;

procedure Form1_TableGrid2_OnClick (Sender: string; vfilm: integer); // click on a CD to find the artist and all the tracks for that CD
begin
  vfilm := sqlexecute('select id_films from nominations where id =' +inttostr(form1.tablegrid2.dbitemid));
  form1.edit1.text := sqlexecute('select title from films where id = '''+inttostr(vfilm)+'''');
  form1.button7.click;
end;

procedure Form1_Image1_OnClick (Sender: TObject);  //** click through to www.awardsdatabase.oscars.org
begin
  openurl('http://awardsdatabase.oscars.org');
end;

procedure formfilm_Image1_OnClick (Sender: TObject); //** click through to www.rottentomatoes.com
begin
  openurl('https://www.rottentomatoes.com/search/?search='+ sqlexecute('select title from films where id =' + form1.tablegrid1.sqlvalue));
end;

procedure Formnom_Image1_OnClick (Sender: TObject); //** click through to www.rottentomatoes.com
begin
  openurl('https://www.rottentomatoes.com/search/?search='+ sqlexecute('select title from films where id =' + form1.tablegrid1.sqlvalue));
end;

// backup database after closing the program
var
   Timer: TTimer;
   iSeconds: integer;

procedure Form1_OnClose (Sender: string; Action: string);
begin
     CopyFile('sqlite.db', 'backup/backup '+ FormatDateTime('dd-mm-yyyy hh-nn-ss', now)+'.db');
     Timer.Free;
end;

   // backup database at a specified time
procedure OnTimer;
begin
     iSeconds := iSeconds + 1;
     if iSeconds > 10800 then // backup every 3 hours (10800 seconds)
     begin
          iSeconds := 0;
          CopyFile('sqlite.db', 'backup/backup '+ FormatDateTime('dd-mm-yyyy hh-nn-ss', now)+'.db');
     end;
end;

// Hidden menu

begin
     Form1.mniFile.Visible := False;

     Form1.mniOptions.Visible := False;
         Form1.mniSettings.Visible := False;
         Form1.mniReport.Visible := False;

     Form1.mniAbout.Visible := False;

     Form1.KeyPreview := True;
end.


